var sqlite={
    open:function(name,callback){
        nemt.sqliteOpen(name);
        if(callback) callback('');
    },
    close:function(name,callback){
        nemt.sqliteClose(name);
        if(callback) callback('');
    },
    delete:function(name,callback){
        nemt.sqliteDelete(name);
        if(callback) callback('');
    },
    execute:function(name,sql,args,callback){
        var id = __event.addEvent(callback);
        nemt.sqliteExecute(name,sql,args,id);
    },
    executenow:function(name,sql,args){
        if(!args) args=[];
        var param = JSON.stringify(args);
        var json = nemt.sqliteExecuteNow(name,sql,param);
        if(json) return JSON.parse(json);
        else return null;
    }
};

var ajax={
    get:function(url,callback){
        var id = __event.addEvent(callback);
        nemt.ajaxGet(url,id);
    },
    post:function(url,data,callback){
        var id = __event.addEvent(callback);
        nemt.ajaxPost(url,JSON.stringify(data),id);
    },
    getnow:function(url){
        return nemt.ajaxGetNow(url);
    },
    load:function(path){
        return nemt.ajaxLoad(path);
    }
};

var device={
    ready:function(callback){
        var ret = nemt.deviceReady();
        if(callback) callback(JSON.parse(ret));
    },
    hide:function(callback){
        nemt.deviceHide();
        if(callback) callback();
    },
    progress:function(value){
        nemt.deviceProgress(value);
    },
    retry:function(){
        nemt.deviceRetry();
    }
};

var scheme={
    openurl:function(url,callback){
        var ret = nemt.schemeOpenURL(url);
        if(callback) callback(JSON.parse(ret));
    },
    copytoclipboard:function(text,callback){
        nemt.schemeCopyToClipboard(text);
        if(callback) callback();
    },
    sharetoweixin:function(params,callback){
        nemt.schemeShareToWeixin(params.url,params.title,params.desc,params.img);
        if(callback) callback();
    },
    sharetofriend:function(params,callback){
        nemt.schemeShareToFriend(params.url,params.title,params.desc,params.img);
        if(callback) callback();
    },
    sharetoqq:function(params,callback){
        nemt.schemeShareToQQ(params.url,params.title,params.desc,params.img);
        if(callback) callback();
    },
    sharetoqzone:function(params,callback){
        nemt.schemeShareToQZone(params.url,params.title,params.desc,params.img);
        if(callback) callback();
    },
};

var pay = {
    alipay:function(params,callback){
        var id = __event.addEvent(callback);
        nemt.payAlipay(params,id);
    },
    wechat:function(params,callback){
        var id = __event.addEvent(callback);
        nemt.payWechat(params.partnerid,params.prepayid,params.noncestr,params.timestamp,params.sign,id);
    },
    registerEvent:function(){
        nemt.registerEvent();
    },
    payEvent:function(){
        nemt.payEvent();
    },
};

var __event = {
    listeners:{},
    addEvent:function(callback){
        var id = 0;
        if(callback && typeof callback === "function"){
            id = 1;
            while(this.listeners[id]) id++;
            this.listeners[id] = callback;
        }
        return id;
    },
    fireEvent:function(id,data){
        var func = this.listeners[id];
        delete this.listeners[id];
        if(typeof func === "function"){
            func(data);
        }
    }
};